local PWB = Protwarbar:getPWB()

function Protwarbar:UpdateShieldBar()
	if PWB.db.profile.shieldFrame.enabled == false then
		return nil
	end

	local barVal = 0
	local barcount = 1
	local time = 0
	local now = GetTime()
	local color = {0, 0, 0 ,0}
	
	for i = 1, PWB_BAR_COUNT do
		if barcount <= PWB.db.profile.shieldFrame.barcount then
			if PWB.db.profile.bars[i].enabled then
				barVal, color, time = Protwarbar:CheckShield(now, PWB.db.profile.bars[i])
				if barVal > 0 then 
					PWB.shieldBars[barcount]:SetValue(barVal)
					PWB.shieldBars[barcount]:SetStatusBarColor(color[1], color[2], color[3], color[4])
					if PWB.db.profile.shieldFrame.infoFrame.enabled then 
						PWB.shieldBarText[barcount]:SetText(string.format("%.1f", time))
					end
					barcount = barcount + 1
				end
			end
		end
	end

	for i = barcount, PWB.db.profile.shieldFrame.barcount do
		PWB.shieldBars[i]:SetValue(0)

		if PWB.db.profile.shieldFrame.infoFrame.enabled then
			PWB.shieldBarText[i]:SetText("")
		end
	end

end

function Protwarbar:CheckShield(now, bar)

	local n,_,_,_,_,d,e,_,_,_,id,_,_,val1,val2,val3 = UnitAura("player", bar.name, nil, "HELPFUL");
	local barVal = 0

	if n then
		local duration = d or 0

		if d > 0 then
			barVal = (e - now) / d * 100
			return  barVal, bar.color, e - now
		end
	end

	return 0, {0,0,0,0}, 0
end